/***************************************************************************
 *   Copyright (C) 2005 by Turulo   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CASILLA_H
#define CASILLA_H
#include <GL/gl.h>
#include <stdio.h>
#include <GL/glut.h>
#include <GL/glu.h>
#include "config.h"
#include "objeto.h"
#include "jugficha.h"

/**
@author Turulo
*/
class Casilla:public Objeto{
public:
    #include "globals.h"
    Casilla();
    ~Casilla();
    void inicializar(int id, GLuint *matriztexturas);
    int id; //Identificador de la casilla
    float rotate;
    int numfichas;
//     bool tiene_barrera;
    int tipo; //Tipo 0 normal, tipo 1 cortada, tipo2 central, tipo3 casa
    void dibujar();
    void setPosicionFicha1(GLfloat x, GLfloat y, GLfloat z);
    void setPosicionFicha2(GLfloat x, GLfloat y, GLfloat z);
    void setPosicionFicha3(GLfloat x, GLfloat y, GLfloat z);
    void setPosicionFicha4(GLfloat x, GLfloat y, GLfloat z);
    /**
     * Funcion que da una posicion nueva para una casilla
     * modifica el numfichas  y devuelve la posicion.
     */
    GLfloat* getNuevaPosicion(int posicion_en_casilla_inicial, int &posicion_en_casilla);
    int maxfichas;
    GLfloat posicion_ficha_1[3];
    bool ocupada_posicion_ficha_1;
    GLfloat posicion_ficha_2[3];
    bool ocupada_posicion_ficha_2;
    GLfloat posicion_ficha_3[3];
    bool ocupada_posicion_ficha_3;
    GLfloat posicion_ficha_4[3];
    bool ocupada_posicion_ficha_4;
    bool es_casilla_segura;
    int texturaactual;
    JugFicha *jugfichas;
};

#endif
