/***************************************************************************
 *   Copyright (C) 2005 by MMM   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "jugador.h"

Jugador::Jugador()
{
  this->posicion_siguiente_texto=0;
  this->ha_tirado=false;
  this->activo=true;
  this->ha_movido=false;
  this->numero_seises=0;
  this->a_casa_por_seises=false;
  this->puede_volver_a_tirar=false;
  this->cuenta20=false;
  this->numfichas=4;
}


Jugador::~Jugador()
{
}


void Jugador::iniciar(int id, Casilla *casillas)
{
  this->id=id;
  this->casillas=casillas;
  switch(id){
      case(0):  
        this->tipo_jugador=0;
        this->setColor(azul);
        sprintf(this->nombrecolor,"azul");
        break;
      case(1):
        this->setColor(rojo);
        this->tipo_jugador=1;
        sprintf(this->nombrecolor,"rojo");
        break;
      case(2):
        this->setColor(verde);
        this->tipo_jugador=2;
        sprintf(this->nombrecolor,"verde");
        break;
      case(3):
        this->setColor(amarillo);
        this->tipo_jugador=3;
        sprintf(this->nombrecolor,"amarillo");
        break;
  }

  for (int i=0;i<this->numfichas;i++){
    this->fichas[i].id_jugador=this->id;
    this->fichas[i].iniciar(i,this->casillas);
    this->fichas[i].posicion_en_casilla_inicial=i+1;
    this->fichas[i].setColor(this->color);
  }
}


/*!
    \fn Jugador::poner_nombre()
 */
void Jugador::poner_nombre()
{
    /// @todo implement me
}


/*!
    \fn Jugador::volver_a_tirar()
 */
bool Jugador::analizando_resultado_dado(int tirada)
{
  //Si fuera un 7 porque tiene todas las fichas fuera
  if (tirada==7)
    tirada=6;

  if (tirada==6){
    this->numero_seises++;
  } else {
    this->numero_seises=0;
    printf ("%s: No puedo volver a tirar\n", this->nombrecolor);
    return false;
  }

  if (this->numero_seises!=3){
    printf ("%s: He sacado %d seis y puedo volver a tirar\n", this->nombrecolor, this->numero_seises);
    this->puede_volver_a_tirar=true;
    return true;
  }else{
    printf ("%s: He sacado tres seises y mi ultima ficha movida se va a la casilla inicial\n", this->nombrecolor);
    printf ("%s: No puedo volver a tirar\n", this->nombrecolor);
    this->numero_seises=0;
    this->a_casa_por_seises=true;
    return false;
  }

}


/*!
    \fn Jugador::puede_mover Funci� que una vez tirada pregunta si puede mover
 */
bool Jugador::puede_mover(int tirada)
{
  for (int i=0;i<4;i++){
    if(this->fichas[i].puede_mover(tirada)){
      printf("%s: Puedo mover y debo seleccionar una de mis fichas\n", this->nombrecolor);
      return true;
    }
  }
//   printf("%s: No puedo mover\n", this->nombrecolor);
  return false;
}


/*!
    \fn Jugador::puede_tirar()
 */
bool Jugador::puede_tirar()
{
    /// @todo implement me
  printf("El jugador %d puede tirar\n", this->id);
  return true;
}


/*!
    \fn Jugador::tiene_todas_fichas_fuera()
 */
bool Jugador::tiene_todas_fichas_fuera()
{ 
  bool resultado=true;
  for (int i=0;i<4;i++){
    if(this->fichas[i].posicion_ruta==0){
      resultado=false;
//       printf("%s: No tengo todas las fichas fuera\n", this->nombrecolor);
      return resultado;
    }
  }
//   printf("%s: Tengo todas las fichas fuera\n", this->nombrecolor);
  return resultado;
}


/*!
    \fn Jugador::TextoEventos_visualizar()
 */
void Jugador::TextoEventos_visualizar()
{
  //Genera las variables
  float posx, posy;
  float posiciontextoeventos[NUMLINEASEVENTOS][2];
  switch(this->id){
    case 0:
      posx=-8;
      posy=7;
      break;
    case 1:
      posx=24;
      posy=7;
      break;
    case 2:
      posx=24;
      posy=22;
      break;
    case 3:
      posx=-8;
      posy=22;
      break;
  }
  for (int i=0;i<NUMLINEASEVENTOS;i++){
    posiciontextoeventos[i][0]=posx;posiciontextoeventos[i][1]=posy;
    posy--;
  }
  //Lo dibuja
  glPushMatrix();
  glColor4f(color[0],color[1],color[2],color[3]);
  for (int i=0;i<NUMLINEASEVENTOS;i++){
//     printf("%f %f\n" ,posiciontextoeventos[i][0] ,posiciontextoeventos[i][1]);
    glRasterPos2f(posiciontextoeventos[i][0] ,posiciontextoeventos[i][1]);
    TextoOGL a; a.drawstring(this->textoeventos[i]);
  }
  glPopMatrix();
}


/*!
    \fn Jugador::TextoEventos_insertar(const char *textoevento)
 */
void Jugador::TextoEventos_insertar(char *textoevento, bool console)
{
//   for (int i=0;i<NUMLINEASEVENTOS-1;i++){
//     strcpy(textoeventos[NUMLINEASEVENTOS-i-1],textoeventos[NUMLINEASEVENTOS-i-2]);
//   }
  if (strlen(textoevento)>255){
    strcpy(textoeventos[this->posicion_siguiente_texto],"Cadena muy larga\n");
  }else{
    strcpy(textoeventos[this->posicion_siguiente_texto],textoevento);
  }
  if (console){
      printf("%s\n", textoevento);
  }
  this->posicion_siguiente_texto++;
}


/*!
    \fn Jugador::TextoEventos_limpiar()
 */
void Jugador::TextoEventos_limpiar()
{
  for (int i=0;i<NUMLINEASEVENTOS;i++){
    strcpy(textoeventos[i],"");
  }
  this->posicion_siguiente_texto=0;
}


/*!
    \fn Jugador::hay_alguna_barrera()
 */
bool Jugador::hay_alguna_barrera()
{
  if(this->fichas[0].posicion_ruta==this->fichas[1].posicion_ruta && this->fichas[0].posicion_ruta!=0 && this->fichas[0].posicion_ruta!=72) return true;
  if(this->fichas[0].posicion_ruta==this->fichas[2].posicion_ruta && this->fichas[0].posicion_ruta!=0 && this->fichas[0].posicion_ruta!=72) return true;
  if(this->fichas[0].posicion_ruta==this->fichas[3].posicion_ruta && this->fichas[0].posicion_ruta!=0 && this->fichas[0].posicion_ruta!=72) return true;
  if(this->fichas[1].posicion_ruta==this->fichas[2].posicion_ruta && this->fichas[1].posicion_ruta!=0 && this->fichas[1].posicion_ruta!=72) return true;
  if(this->fichas[1].posicion_ruta==this->fichas[3].posicion_ruta && this->fichas[1].posicion_ruta!=0 && this->fichas[1].posicion_ruta!=72) return true;
  if(this->fichas[2].posicion_ruta==this->fichas[3].posicion_ruta && this->fichas[2].posicion_ruta!=0 && this->fichas[2].posicion_ruta!=72) return true;

  return false;

}
