//
// C++ Implementation: menuitem
//
// Description: 
//
//
// Author: Turulo <turulomio@yahoo.es>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "menuitem.h"

MenuItem::MenuItem()
{
  menuitem_textura_texto=false;
}


MenuItem::~MenuItem()
{
}

void MenuItem::iniciar(int id)
{
  this->id=id;
  this->setColor(this->blanco);
  switch(id){
    case 0:
      this->setPosicion(5,18,1);
      break;
    case 1:
      this->setPosicion(1,13,1);
      break;
    case 2:
      this->setPosicion(6,3,1);
      break;
    case 3:
      this->setPosicion(1,18,1);
      break;
    case 4:
      this->setPosicion(1,13,1);
      break;
    case 5:
      this->setPosicion(5,8,1);
      break;
    case 6:
      this->setPosicion(0,4,5);
      break;
    case 7:
      this->setPosicion(2,8,1);
      break;
    case 8: //Casilla final
      this->setPosicion(1,4,5);
      break;
    case 9:
      this->setPosicion(3,18,5);
      break;
    case 10:
      this->setPosicion(3,13,5);
      break;
    case 11:
      this->setPosicion(3,8,5);
      break;
    case 12:
      this->setPosicion(3,3,5);
      break;
    case 13:
      this->setPosicion(10,18,5);
      break;
    case 14:
      this->setPosicion(10,13,5);
      break;
    case 15:
      this->setPosicion(10,8,5);
      break;
    case 16:
      this->setPosicion(10,3,5);
      break;
    case 17:
      this->setPosicion(8,-2,5);
      break;
    case 18:
      this->setPosicion(7,-1,5);
      break;
    case 19:
      this->setPosicion(7,-1,5);
      break;
    case 20:
      this->setPosicion(22,-3,5);
      break;

  }
}


/*!
    \fn MenuItem::dibujar(int textura)
 */
void MenuItem::dibujar(int idtipojugador)
{
  glInitNames();
  glPushName(0);
  glPushMatrix();

  glTranslated(posicion[0],posicion[1],posicion[2]);
  glColor4f(color[0],color[1],color[2],color[3]);
  //A�dir nombre a la ficha

  switch(this->id){
    case 0:
      glScaled(12,3,0);
      glPushName(JUGAR);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eJugar);
      break;
    case 1:
      glScaled(20,3,0);
      glPushName(OPCIONES);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eOpciones);
      break;
    case 2:
      glScaled(10,3,0);
      glPushName(SALIR);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eSalir);
      break;
    case 3:
      glScaled(20,3,0);
      glPushName(JUGADORES);
      glBindTexture(GL_TEXTURE_2D, eJugadores);
      menuitem_textura_texto=true;
      break;
    case 4:
      glScaled(20,3,0);
      glPushName(CONTROLES);
      glBindTexture(GL_TEXTURE_2D, eControles);
      menuitem_textura_texto=true;
      break;
    case 5:
      glScaled(12,3,0);
      glPushName(VOLVER);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eVolver);
      break;
    case 6:
      glScaled(22,20,0);
//       glPushName(VOLVER_DE_CONTROLES);
      glBindTexture(GL_TEXTURE_2D, ePantallaInicio);
      break;
    case 7:
      glScaled(18,3,0);
      glPushName(CREDITOS);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eCreditos);
      break;
    case 8: //Pantalla final
      glScaled(22,18,0);
//       glPushName(VOLVER_DE_CREDITOS);
      glBindTexture(GL_TEXTURE_2D, ePantallaFinal);
      break;
    case 9: //Juga 1 selector
      glScaled(4,4,0);
      glPushName(SELECTOR0);
      this->textura_jugador(idtipojugador);
      break;
    case 10: //Juga 2 selector
      glScaled(4,4,0);
      glPushName(SELECTOR1);
      this->textura_jugador(idtipojugador);
      break;
    case 11: //Juga 3 selector
      glScaled(4,4,0);
      glPushName(SELECTOR2);
      this->textura_jugador(idtipojugador);
      break;
    case 12: //Juga 4 selector
      glScaled(4,4,0);
      glPushName(SELECTOR3);
      this->textura_jugador(idtipojugador);
      break;
    case 13: //Juga 0
      glScaled(10,3,0);
//       glPushName(NONE);
      menuitem_textura_texto=true;
      this->setColor(this->azul);
      glBindTexture(GL_TEXTURE_2D, eJugadores);
      break;
    case 14: //Juga 1
      glScaled(10,3,0);
//       glPushName(NONE);
      menuitem_textura_texto=true;
      this->setColor(this->rojo);
      glBindTexture(GL_TEXTURE_2D, eJugadores);
      break;
    case 15: //Juga 2
      glScaled(10,3,0);
//       glPushName(NONE);
      menuitem_textura_texto=true;
      this->setColor(this->verde);
      glBindTexture(GL_TEXTURE_2D, eJugadores);
      break;
    case 16: //Juga 3 
      glScaled(10,3,0);
//       glPushName(NONE);
      menuitem_textura_texto=true;
      this->setColor(this->amarillo);
      glBindTexture(GL_TEXTURE_2D, eJugadores);
      break;
    case 17: //Volver de jugadores
      glScaled(8,3,0);
      menuitem_textura_texto=true;
      glPushName(VOLVER_DE_JUGADORES);
      glBindTexture(GL_TEXTURE_2D, eVolver);
      break;
    case 18: //Pantalla final
      glScaled(8,3,0);
      glPushName(VOLVER_DE_CREDITOS);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eVolver);
      break;
    case 19: //Controles
      glScaled(8,3,0);
      glPushName(VOLVER_DE_CONTROLES);
      menuitem_textura_texto=true;
      glBindTexture(GL_TEXTURE_2D, eVolver);
      break;
    case 20: //Versión
      glScaled(5,1,0);
      menuitem_textura_texto=true;
      this->setColor(this->verde);
      glBindTexture(GL_TEXTURE_2D, eVersion);
      break;

  }
  if(this->menuitem_textura_texto){
    this->plano_texto();
  }else{
    this->plano(); 
  }
  glPopName();
  glPopMatrix();
}


/*!
    \fn MenuItem::textura_jugador(int tipojugador)
 */
void MenuItem::textura_jugador(int tipojugador)
{
  switch(tipojugador){
    case -1:
      this->setColor(this->blanco);
      glBindTexture(GL_TEXTURE_2D, eSinUsuario);
      break;
    case 0:
      this->setColor(this->blanco);
      glBindTexture(GL_TEXTURE_2D, eCasillaInicioHuman);
      break;
    case 1:
      this->setColor(this->verde);
      glBindTexture(GL_TEXTURE_2D, eCasillaInicioPC);
      break;
    case 2:
      this->setColor(this->amarillo);
      glBindTexture(GL_TEXTURE_2D, eCasillaInicioPC);
      break;
    case 3:
      this->setColor(this->rojo);
      glBindTexture(GL_TEXTURE_2D, eCasillaInicioPC);
      break;
  }
}
