/***************************************************************************
 *   Copyright (C) 2005 by Turulo   *
 *   mamuma@eresmas.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PARTIDA_H
#define PARTIDA_H
#include <libintl.h>
#include "SDL.h"
#include "dado.h"
#include "jugador.h"
#include "ficha.h"
#include "tablero.h"
#include "sound.h"
#include "identificadorjugador.h"
#include "ia.h"
#include "modelo.h"
#include "testeo.h"
#include "textura.h"
#include "time.h" 
#include <unistd.h>
/**
@author Turulo
*/
class Partida{ 
public:
  #include "globals.h"
  Partida();
  ~Partida();
  void siguiente_jugador();
  bool ha_finalizado();
  void after_clicking_dado();
  void after_clicking_any_ficha(JugFicha jugfic);
  void ProcessObjeto(GLuint *pSelectBuff,int hits,bool rightmousebutton);
  int * jugadores_fichas_en_casilla(int idCasilla);
  void RenderScene();
  void KeyPressFunc(unsigned char key, int x, int y);
  void EndRenderScene();
  bool hay_ficha_mismo_jugador(int id_casilla, int id_jugador_recien_movido);
  void show_ids_ficha(int id);
  JugFicha idprocess2JugFicha(int idProcess);
  int casilla_tiene_barrera(int idcasilla);
  bool alguna_puede_mover();
  bool puede_mover(JugFicha j);
  bool puede_tirar_otra_vez();
  bool alguna_ficha_forzada_a_mover();
  int alguna_ficha_forzada_a_mover_automaticamente();
  bool come();
  bool llega_a_casa();
  bool mueve();
  void tirando_dado();
  void ia_emulate_dado();
  void ia_emulate_ficha();
  bool es_casilla_segura(int id_casilla);
  int numero_jugadores;
  int numero_cambios_jugador;
  Dado *dado;
  Jugador jugadores[4];
  Casilla casillas[104];
  Ficha *ficha_sel;
  Jugador *jugador_actual;
  Tablero *tablero;
  bool salir;
  Textura *t;
  IA *ia;
  Sound *s;
  GLfloat rot;
  Modelo *m;
  int vista;
  /*!
     Variable que puede ser -1 cuando se está en menu
     0 al finalizar la partida
     1 para esperar evento de dado
     2 para esperar evento de ficha.
   */
  int estado_eventos;
  IdentificadorJugador *identificadorjugador;
  bool visible;
  bool showcontroles;
  Testeo *testeo;
};

#endif
