/* $Id: sound.h,v 1.1 2006/09/08 16:32:58 keko Exp $ */
/*
   Copyright (C) 2003 by David White <davidnwhite@verizon.net>
   Part of the Battle for Wesnoth Project http://www.wesnoth.org/

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License.
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY.

   See the COPYING file for more details.
*/
#ifndef SOUND_H_INCLUDED
#define SOUND_H_INCLUDED

#include <string>
#include <stdio.h>
#include <config.h>

#include <SDL.h>
#include <SDL_mixer.h>

#include <iostream>
#include <map>

#define LOG_AUDIO LOG_STREAM(info, audio)
#define ERR_AUDIO LOG_STREAM(err, audio)

namespace {
bool mix_ok = false;
std::map<std::string,Mix_Chunk*> sound_cache;
std::map<std::string,Mix_Music*> music_cache;

char current_music[1000];
}

class Sound{
public:
Sound();
~Sound();
bool init_sound();
void close_sound();

void stop_music();
void stop_sound();

void play_music(char * file);
void play_sound(char * file);

void set_music_volume(int vol);
void set_sound_volume(int vol);

};

#endif
